From e0d971054facac641e2424074229d692b6077aa2 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Fr=C3=A9d=C3=A9ric=20P=C3=A9ters?= <fpeters@entrouvert.com>
Date: Sat, 20 Nov 2021 20:52:29 +0100
Subject: [PATCH 2/2] misc: apply form title style to new .form-content--title
 (#58805)

---
 static/amiens-metropole/_custom.scss       | 2 +-
 static/arpajon/_custom.scss                | 2 +-
 static/cinor-2021/_custom.scss             | 1 +
 static/cinor/_custom.scss                  | 1 +
 static/cotes-d-armor/_custom.scss          | 1 +
 static/dordogne-cd24/_custom.scss          | 2 ++
 static/grandlyon/_custom.scss              | 3 ++-
 static/la-reunion-region/_custom.scss      | 1 +
 static/la-rochelle/_custom.scss            | 1 +
 static/lille/_custom.scss                  | 1 +
 static/minint/sass/_form.scss              | 1 +
 static/minint/sass/_team.scss              | 1 +
 static/montlouis-sur-loire/_custom.scss    | 1 +
 static/orleans/_custom.scss                | 1 +
 static/quimper/_custom.scss                | 1 +
 static/roannais-agglomeration/_custom.scss | 1 +
 static/sables-d-olonne/_custom.scss        | 1 +
 static/saint-chamond/_custom.scss          | 1 +
 static/saint-laurent-du-var/_custom.scss   | 3 ++-
 static/saint-lo-agglo/_custom.scss         | 2 ++
 static/signal-publik/_custom.scss          | 1 +
 static/strasbourg-2018/_custom.scss        | 1 +
 static/tournai/_custom.scss                | 1 +
 static/villejuif/_custom.scss              | 1 +
 24 files changed, 28 insertions(+), 4 deletions(-)

diff --git a/static/amiens-metropole/_custom.scss b/static/amiens-metropole/_custom.scss
index 4f4d89af..fc0374f6 100644
--- a/static/amiens-metropole/_custom.scss
+++ b/static/amiens-metropole/_custom.scss
@@ -14,7 +14,7 @@ a#publik-portal-agent,
 	div.links-list h2, div#services > ul > li > strong > a,
 	#content div.textcell h2:first-child,
 	#content div.cell h2:first-child,
-	div#tracking-code h3, div#rub_service h2 {
+	div#tracking-code h3, div#rub_service h2, .form-content--title {
 		@extend %title-style;
 	}
 }
diff --git a/static/arpajon/_custom.scss b/static/arpajon/_custom.scss
index 08a69020..82ee475a 100644
--- a/static/arpajon/_custom.scss
+++ b/static/arpajon/_custom.scss
@@ -82,7 +82,7 @@ body.has-picture .site-nav::after {
 }
 
 div#tracking-code h3,
-div#rub_service h2,
+div#rub_service h2, .form-content--title,
 div#rub_service div.category h3,
 .gru-content div.a2-block h2,
 .gru-content div.block h2,
diff --git a/static/cinor-2021/_custom.scss b/static/cinor-2021/_custom.scss
index 917eaef0..e0c5d8bf 100644
--- a/static/cinor-2021/_custom.scss
+++ b/static/cinor-2021/_custom.scss
@@ -252,6 +252,7 @@ div.text-cell {
 	}
 }
 // Title
+.form-content--title,
 div#rub_service h2 {
 	font-size: 2.5em;
 	padding-left: 0;
diff --git a/static/cinor/_custom.scss b/static/cinor/_custom.scss
index 4e6db3a5..98baee06 100644
--- a/static/cinor/_custom.scss
+++ b/static/cinor/_custom.scss
@@ -238,6 +238,7 @@ div.text-cell {
 	}
 }
 // Title
+.form-content--title,
 div#rub_service h2 {
 	font-size: 2.5em;
 	padding-left: 0;
diff --git a/static/cotes-d-armor/_custom.scss b/static/cotes-d-armor/_custom.scss
index 358fb25a..023e324a 100644
--- a/static/cotes-d-armor/_custom.scss
+++ b/static/cotes-d-armor/_custom.scss
@@ -71,6 +71,7 @@ footer {
 	}
 }
 
+.form-content--title,
 div#rub_service h2 {
 	text-align: left;
 }
diff --git a/static/dordogne-cd24/_custom.scss b/static/dordogne-cd24/_custom.scss
index 2fa3496d..90da7bc2 100644
--- a/static/dordogne-cd24/_custom.scss
+++ b/static/dordogne-cd24/_custom.scss
@@ -457,10 +457,12 @@ h1, h2, h3, h4 {
 	text-transform: uppercase;
 }
 
+.form-content--title,
 h1, div#rub_service h2 {
 	font-size: 1.667rem;
 }
 
+.form-content--title,
 div#rub_service h2 {
 	@include after-line();
 }
diff --git a/static/grandlyon/_custom.scss b/static/grandlyon/_custom.scss
index cf31d765..22403b8f 100644
--- a/static/grandlyon/_custom.scss
+++ b/static/grandlyon/_custom.scss
@@ -63,6 +63,7 @@ div.list-of-forms span.form-number {
 	opacity: 0.7;
 }
 
+.form-content--title,
 div#rub_service h2 {
 	text-align: left;
 }
@@ -71,4 +72,4 @@ div#rub_service h2 {
 	@extend %button;
 	display: inline-block;
 	background-color: $primary-color;
-}
\ No newline at end of file
+}
diff --git a/static/la-reunion-region/_custom.scss b/static/la-reunion-region/_custom.scss
index 8137b159..d3696c06 100644
--- a/static/la-reunion-region/_custom.scss
+++ b/static/la-reunion-region/_custom.scss
@@ -187,6 +187,7 @@ div.wcs-form-cell a {
 }
 
 // WCS
+.form-content--title,
 div#rub_service h2 {
 	font-size: 2rem;
 	color: $primary-color;
diff --git a/static/la-rochelle/_custom.scss b/static/la-rochelle/_custom.scss
index d5798e51..e3517409 100644
--- a/static/la-rochelle/_custom.scss
+++ b/static/la-rochelle/_custom.scss
@@ -70,6 +70,7 @@ div#columns div.cell, div#rub_service div.comment-field {
 	}
 }
 
+.form-content--title,
 div#rub_service h2 {
 	text-transform: none;
 	font-size: 20px;
diff --git a/static/lille/_custom.scss b/static/lille/_custom.scss
index a752d000..a39742d6 100644
--- a/static/lille/_custom.scss
+++ b/static/lille/_custom.scss
@@ -768,6 +768,7 @@ div#rub_service div.dataview {
 	font-size: 90%;
 }
 
+.form-content--title,
 div#rub_service h2 {
 	padding-left: 0;
 }
diff --git a/static/minint/sass/_form.scss b/static/minint/sass/_form.scss
index 68b3a58e..123e6cd0 100644
--- a/static/minint/sass/_form.scss
+++ b/static/minint/sass/_form.scss
@@ -23,6 +23,7 @@
 
 
 // annule le code en place
+.form-content--title,
 div#rub_consultation h2,
 div#rub_service h2,
 div#rub_annonce h2,
diff --git a/static/minint/sass/_team.scss b/static/minint/sass/_team.scss
index d9bbbda4..7db2b8f5 100644
--- a/static/minint/sass/_team.scss
+++ b/static/minint/sass/_team.scss
@@ -103,6 +103,7 @@ div#gauche { float: none; width: 100%;
 @media (max-width: 768px) {
 
   div#rub_consultation h2,
+  .form-content--title,
   div#rub_service h2,
   div#rub_annonce h2,
   div#rub_agenda h2,
diff --git a/static/montlouis-sur-loire/_custom.scss b/static/montlouis-sur-loire/_custom.scss
index 6dc45119..fbb257ab 100644
--- a/static/montlouis-sur-loire/_custom.scss
+++ b/static/montlouis-sur-loire/_custom.scss
@@ -635,6 +635,7 @@ div#rub_service div.submit-button {
 	float: right;
 }
 
+.form-content--title,
 div#rub_service h2 {
 	text-align: left;
 	color: $primary-color;
diff --git a/static/orleans/_custom.scss b/static/orleans/_custom.scss
index dbc7e83c..0f552b26 100644
--- a/static/orleans/_custom.scss
+++ b/static/orleans/_custom.scss
@@ -189,6 +189,7 @@ div.bookingcalendar table td.available {
 
 /* w.c.s. forms */
 
+.form-content--title,
 div#rub_service h2 {
 	background: #F5F5F5;
 	font-family: the_sans_bold, Arial, Helvetica, sans-serif;
diff --git a/static/quimper/_custom.scss b/static/quimper/_custom.scss
index cdd1f174..a8665e91 100644
--- a/static/quimper/_custom.scss
+++ b/static/quimper/_custom.scss
@@ -661,6 +661,7 @@ div#rub_service h4[data-field-id] {
 	color: $title-color;
 }
 
+.form-content--title,
 div#rub_service h2 {
 	text-align: left;
 }
diff --git a/static/roannais-agglomeration/_custom.scss b/static/roannais-agglomeration/_custom.scss
index 503a27a8..192962b1 100644
--- a/static/roannais-agglomeration/_custom.scss
+++ b/static/roannais-agglomeration/_custom.scss
@@ -152,6 +152,7 @@ div.comment-field {
 	}
 }
 
+.form-content--title,
 div#rub_service h2 {
 	text-align: left;
 	color: #1c1c1c;
diff --git a/static/sables-d-olonne/_custom.scss b/static/sables-d-olonne/_custom.scss
index 00bb0d29..9c8385d6 100644
--- a/static/sables-d-olonne/_custom.scss
+++ b/static/sables-d-olonne/_custom.scss
@@ -316,6 +316,7 @@ body:not(.wcs-page) {
 	@include big-line(left, $cyan);
 }
 
+.form-content--title,
 div#rub_service h2 {
 	@extend .desktop-only;
 	@extend .wcs-page-title;
diff --git a/static/saint-chamond/_custom.scss b/static/saint-chamond/_custom.scss
index 621f2af7..08acc5d2 100644
--- a/static/saint-chamond/_custom.scss
+++ b/static/saint-chamond/_custom.scss
@@ -166,6 +166,7 @@ div.infonotice {
 	}
 }
 
+.form-content--title,
 div#rub_service h2 {
 	text-align: left;
 	color: #545454;
diff --git a/static/saint-laurent-du-var/_custom.scss b/static/saint-laurent-du-var/_custom.scss
index 50f8a621..13b788f0 100644
--- a/static/saint-laurent-du-var/_custom.scss
+++ b/static/saint-laurent-du-var/_custom.scss
@@ -235,6 +235,7 @@ ul#evolutions li span.item {
 	box-shadow: 0 0 0px 5px $sldv-main-color;
 }
 
+.form-content--title,
 div#rub_service h2 {
 	@extend %big-title;
 }
@@ -290,4 +291,4 @@ div#tracking-code a {
 			transition: color 0.4s;
 		}
 	}
-}
\ No newline at end of file
+}
diff --git a/static/saint-lo-agglo/_custom.scss b/static/saint-lo-agglo/_custom.scss
index b5014139..5744beb9 100644
--- a/static/saint-lo-agglo/_custom.scss
+++ b/static/saint-lo-agglo/_custom.scss
@@ -89,10 +89,12 @@ div.cell h1 {
 	text-transform: uppercase;
 }
 
+.form-content--title,
 div#rub_service h2 {
 	text-align: left;
 }
 
+.form-content--title,
 div#rub_service h2,
 div#rub_service div.dataview, div#rub_service dl#evolutions, div#rub_service form {
 	padding-left: 0;
diff --git a/static/signal-publik/_custom.scss b/static/signal-publik/_custom.scss
index 24bab3e8..b27d56e3 100644
--- a/static/signal-publik/_custom.scss
+++ b/static/signal-publik/_custom.scss
@@ -683,6 +683,7 @@ div#rub_service h4[data-field-id] {
 	color: $title-color;
 }
 
+.form-content--title,
 div#rub_service h2 {
 	text-align: left;
 }
diff --git a/static/strasbourg-2018/_custom.scss b/static/strasbourg-2018/_custom.scss
index 9af01e38..0427f802 100644
--- a/static/strasbourg-2018/_custom.scss
+++ b/static/strasbourg-2018/_custom.scss
@@ -22,6 +22,7 @@
 /* cancel hyphenation of some elements */
 @media screen and (min-width: 500px) {
 	#side #steps ol li .label,
+	.form-content--title,
 	.section-demarches #rub_service h2,
 	#content div.textcell h2, #content h2 {
 		hyphens: none;
diff --git a/static/tournai/_custom.scss b/static/tournai/_custom.scss
index 5203285a..0d11d02a 100644
--- a/static/tournai/_custom.scss
+++ b/static/tournai/_custom.scss
@@ -218,6 +218,7 @@ div#rub_service div.submit-button {
 	float: right;
 }
 
+.form-content--title,
 div#rub_service h2 {
 	text-align: left;
 	color: $primary-color;
diff --git a/static/villejuif/_custom.scss b/static/villejuif/_custom.scss
index 02682e7b..27642103 100644
--- a/static/villejuif/_custom.scss
+++ b/static/villejuif/_custom.scss
@@ -330,6 +330,7 @@ div.BlockSubWidget div.content {
 	border-left: 1px solid $primary-color;
 }
 
+.form-content--title,
 div#rub_service h2 {
 	-webkit-border-radius: 5px;
 	-moz-border-radius: 5px;
-- 
2.33.1